org.deidentifier.arx.criteria

## Class DPresence

- java.lang.Object
- - org.deidentifier.arx.criteria.PrivacyCriterion
  - - org.deidentifier.arx.criteria.ImplicitPrivacyCriterion
    - - org.deidentifier.arx.criteria.DPresence

All Implemented Interfaces:
  java.io.Serializable

Direct Known Subclasses:
  Inclusion

    public class DPresence
    extends ImplicitPrivacyCriterion

The d-presence criterion Published in: Nergiz M, Atzori M, Clifton C. Hiding the presence of individuals from shared databases. Proceedings of the 2007 ACM SIGMOD international conference on Management of data. 2007:665-676.

Author:
  Fabian Prasser, Florian Kohlmayer
See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`DPresence(double dMin, double dMax, DataSubset subset)` Creates a new instance of the d-presence criterion as proposed in: Nergiz M, Atzori M, Clifton C.

### Method Summary

All Methods Instance Methods Concrete Methods
`DPresence` `clone()` Clone
`DataSubset` `getDataSubset()` If a privacy model uses a data subset, it must overwrite this method
`double` `getDMax()` Returns dMax.
`double` `getDMin()` Returns dMin.
`int` `getRequirements()` Returns the criterion's requirements.
`void` `initialize(DataManager manager, ARXConfiguration config)` Override this to initialize the criterion.
`boolean` `isAnonymous(Transformation<?> node, HashGroupifyEntry entry)` Implement this, to enforce the criterion.
`boolean` `isLocalRecodingSupported()` Returns whether the criterion supports local recoding.
`boolean` `isSubsetAvailable()` If a privacy model uses a data subset, it must overwrite this method
`ElementData` `render()` Renders the privacy model
`java.lang.String` `toString()` Returns a string representation.

### Methods inherited from class org.deidentifier.arx.criteria.PrivacyCriterion

`clone, getMinimalClassSize, getPopulationModel, getRiskThresholdJournalist, getRiskThresholdMarketer, getRiskThresholdProsecutor, getSubset, isHeuristicSearchSupported, isHeuristicSearchWithTimeLimitSupported, isMinimalClassSizeAvailable, isMonotonicWithGeneralization, isMonotonicWithSuppression, isOptimalSearchSupported, isSampleBased`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### DPresence

    public DPresence(double dMin,
                     double dMax,
                     DataSubset subset)

Creates a new instance of the d-presence criterion as proposed in: Nergiz M, Atzori M, Clifton C. Hiding the presence of individuals from shared databases. Proceedings of the 2007 ACM SIGMOD international conference on Management of data. 2007:665-676.

Parameters:
  `dMin` - Delta min
  `dMax` - Delta max
  `subset` - Research subset

### Method Detail

#### clone

    public DPresence clone()

Description copied from class: `PrivacyCriterion`
Clone

Specified by:
  `clone` in class `PrivacyCriterion`

#### getDataSubset

    public DataSubset getDataSubset()

Description copied from class: `PrivacyCriterion`
If a privacy model uses a data subset, it must overwrite this method

Overrides:
  `getDataSubset` in class `PrivacyCriterion`
Returns:

#### getDMax

    public double getDMax()

Returns dMax.

Returns:

#### getDMin

    public double getDMin()

Returns dMin.

Returns:

#### getRequirements

    public int getRequirements()

Description copied from class: `PrivacyCriterion`
Returns the criterion's requirements.

Specified by:
  `getRequirements` in class `PrivacyCriterion`
Returns:

#### initialize

    public void initialize(DataManager manager,
                           ARXConfiguration config)

Description copied from class: `PrivacyCriterion`
Override this to initialize the criterion.

Overrides:
  `initialize` in class `PrivacyCriterion`
  `config` - TODO

#### isAnonymous

    public boolean isAnonymous(Transformation<?> node,
                               HashGroupifyEntry entry)

Description copied from class: `PrivacyCriterion`
Implement this, to enforce the criterion.

Specified by:
  `isAnonymous` in class `PrivacyCriterion`
Parameters:
  `node` - TODO
Returns:

#### isLocalRecodingSupported

    public boolean isLocalRecodingSupported()

Description copied from class: `PrivacyCriterion`
Returns whether the criterion supports local recoding.

Specified by:
  `isLocalRecodingSupported` in class `PrivacyCriterion`
Returns:

#### isSubsetAvailable

    public boolean isSubsetAvailable()

Description copied from class: `PrivacyCriterion`
If a privacy model uses a data subset, it must overwrite this method

Overrides:
  `isSubsetAvailable` in class `PrivacyCriterion`
Returns:

#### render

    public ElementData render()

Description copied from class: `PrivacyCriterion`
Renders the privacy model

Specified by:
  `render` in class `PrivacyCriterion`
Returns:

#### toString

    public java.lang.String toString()

Description copied from class: `PrivacyCriterion`
Returns a string representation.

Specified by:
  `toString` in class `PrivacyCriterion`